using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Utilities.Todo.Cqrs;

public record DeleteTodoItemCommand(string Id) : IRequest<bool>;

public class DeleteTodoItemHandler : IRequestHandler<DeleteTodoItemCommand, bool>
{
    private readonly AppDbContext _context;

    public DeleteTodoItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteTodoItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.TodoItem
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null)
        {
            return false;
        }

        _context.TodoItem.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}